#!/usr/bin/perl -w
# minordomo.pl - This is minordomo, a minimalistic mailing list manager
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. And also
# please DO NOT REMOVE my name, and give me a CREDIT when you use
# whole or a part of this program in an other program.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
use CGI;
use strict;

# You may wish to edit this if you are using a different config file
my $config = "/etc/minordomo.conf";

# The version of minordomo
my $version = "minordomo 0.7";

# Set up default values
my $smtp_server = 'localhost';
my $directory = '/var/lib/minordomo';
my $admin = 'root@localhost';
my $domain = 'localdomain.com';
my @archive = ();
my @list_cmd = ();
my @open_lists = ();
my $subject_pre = '';
my $url = '';
my $message = '';

my $bgcolor = '#FFFFFF';
my $text    = '#000000';
my $link    = '#0000FF';
my $vlink   = '#FF00FF';
my $alink   = '#FF0000';
my $wfooter = '<HR>';

# Read the config file
do_conf($config);

$url = 'http://www.ndn.net/perl/minorweb.pl';
my $minor_url = $url;

my $action = CGI::param('A') ? CGI::param('A') : 'LIST';
my $list   = CGI::param('L');
my $year   = CGI::param('Y') ? CGI::param('Y') : 'NONE';
my $month  = CGI::param('M') ? CGI::param('M') : 'NONE';
my $daydir = CGI::param('D') ? CGI::param('D') : 'NONE';
my $id     = CGI::param('I');

# Month hash
my %m = ('1'=>'January', '2'=>'February', '3'=>'March', '4'=>'April',
	'5'=>'May', '6'=>'June', '7'=>'July', '8'=>'August', '9'=>'September',
	'10'=>'October', '11'=>'November', '12'=>'December');

if (-s "$directory/web.config") { do_conf("$directory/web.config"); }
if (-s "$directory/web.footer") {
 open FOOT, "$directory/web.footer";
 while (<FOOT>) { $wfooter .= $_ }
 close FOOT;
}

if ($list) {
 if (-s "$directory/$list/web.config"){do_conf("$directory/$list/web.config");}
 if (-s "$directory/$list/web.footer"){
  open FOOT,"$directory/$list/web.footer";
  while (<FOOT>) { $wfooter .= $_ }
  close FOOT;
 }
}

if ($action eq 'LIST'){

  if (!($list)){
    my $lists = '';
    my $star = 'no';
    header("Choose a list");
    print "<H2>Please choose a list to view the archives of</H2>";
    foreach (@main::archive){
      if ($_ eq "*") {
        $lists = '';
        $star = 'yes';
        opendir(DIR, $directory);
        foreach (readdir(DIR)){ if (-x "$directory/$_"){ $lists .= "$_ "; } }
        closedir(DIR);
      } elsif($star eq 'no') { $lists .= "$_ "; }
    }
    if ($lists ne '') {
      $lists =~ s/\.\. //g;
      $lists =~ s/\. //g;
      @archive = split (/ /, $lists);
    }
    foreach (@archive){ print "<A HREF=\"$minor_url?A=LIST&L=$_\">$_</A><BR>"; }
    footer($wfooter);
  } elsif ($year eq 'NONE'){
    opendir(DIR, "$directory/$list/archive");
    my @years = readdir(DIR);
    closedir(DIR);
    my $yearlist = join(" ", @years);
    $yearlist =~ s/\.\. //g;
    $yearlist =~ s/\. //g;
    @years = split(/ /, $yearlist);
    header("Archives of $list by year");
    print "<H2>Please choose the year to view</H2>";
    foreach (@years){
      print "<A HREF=\"$minor_url?A=LIST&L=$list&Y=$_\">$_</A><BR>";
    }
    footer($wfooter);
  } elsif ($month eq 'NONE') {
    opendir(DIR, "$directory/$list/archive/$year");
    my @months = readdir(DIR);
    closedir(DIR);
    my $monthlist = join(" ", @months);
    $monthlist =~ s/\.\. //g;
    $monthlist =~ s/\. //g;
    @months = split(/ /, $monthlist);
    header("Archives of $list by month in $year");
    print "<H2>Please choose a month to view</H2>";
    foreach (@months){
      print "<A HREF=\"$minor_url?A=LIST&L=$list&Y=$year&M=$_\">$m{$_}</A><BR>";
    }
    footer($wfooter);
  } else {
    my $sort = CGI::param('S') ? CGI::param('S') : 'SUBJ';
    my %days;
    my $day;
    my @subjs;
    my @names;
    my @emails;
    my @dates;
    my @di;
    header("Archives of $list for $m{$month} $year");
    opendir(MONTH, "$directory/$list/archive/$year/$month");
    my @days = readdir(MONTH);
    closedir(MONTH);
    my $i = 0;
    foreach $day (@days) {
      if ($day ne "." && $day ne "..") {
        opendir (DAY, "$directory/$list/archive/$year/$month/$day");
        my @daylist = readdir(DAY);
        foreach $id (@daylist) {
          unless ($id eq "." or $id eq "..") {
           my $buf = '';
           open FILE, "$directory/$list/archive/$year/$month/$day/$id"; 
           while (<FILE>) { $buf .= $_ }
           close FILE;
           $buf =~ s/\r//g;
           my ($header, $message) = split(/\n\n/, $buf, 2);
           my @header = split(/\n/, $header);
           foreach (@header){
             if ($_ =~ /^from:/ig) { $names[$i] = $_; $emails[$i] = $_; }
             elsif ($_ =~ /^date:/ig) { $dates[$i] = $_; }
             elsif ($_ =~ /^subject:/ig) { $subjs[$i] = $_; }
           }
            $subjs[$i]  =~ s/^subject: //ig;
            $dates[$i]  =~ s/^date: //ig;
            $names[$i]  =~ s/^from: //ig;
            $names[$i] =~ s/<.*>//;
            $names[$i] =~ s/"//g;
            $emails[$i] =~ s/^from: //ig;
            $emails[$i] =~ s/.*\<//;
            $emails[$i] =~ s/\>.*//;
            $di[$i]     = "$day:$id";
	    if (!$subjs[$i]) { $subjs[$i] = "Unknown Subject" }
            $i++;
          }
        }
        closedir(DAY);
      }
    }

    print "<TABLE WIDTH=\"100%\" BORDER=\"0\">";
    print "<TR><TH ALIGN=\"CENTER\">";
    #print "<A HREF=\"$minor_url?A=LIST&L=$list&Y=$year&M=$month&S=SUBJ\">";
    print "Subject<!-- </A> --></TH><TH ALIGN=\"CENTER\">";
    #print "<A HREF=\"$minor_url?A=LIST&L=$list&Y=$year&M=$month&S=AUTH\">";
    print "Author<!-- </A> --></TH><TH ALIGN=\"CENTER\">";
    #print "<A HREF=\"$minor_url?A=LIST&L=$list&Y=$year&M=$month&S=DATE\">";
    print "Date<!-- </A> --></TH></TR>\n";
   
#FIXME: Sort things here
    for $i (0 .. $#subjs) {
     my ($d, $id) = split(/:/, $di[$i]);
     print "<TR><TD ALIGN=\"LEFT\">";
     print "<A HREF=\"$minor_url?A=READ&L=$list&Y=$year&M=$month&D=$d&I=$id\">";
     print "$subjs[$i]</A>";
     print "</TD><TD ALIGN=\"LEFT\">";
     print "<A HREF=\"mailto:$emails[$i]\">$names[$i]</A>";
     print "</TD><TD ALIGN=\"LEFT\">";
     print "$dates[$i]";
     print "</TD></TR>\n";
    }

    print "</TABLE>";
    footer($wfooter);
  }

} elsif ($action eq 'READ') {
  if (!($list && $year && $month)){
    print "Location: $minor_url?A=LIST&L=$list&Y=$year&M=$month\n\n";
  } else {
    # open up the header and read it in
    my $buf = '';
    open FILE, "$directory/$list/archive/$year/$month/$daydir/$id";
    while (<FILE>) { $buf .= $_ }
    close FILE;
    $buf =~ s/</&lt\;/g;
    $buf =~ s/>/&gt\;/g;
    $buf =~ s/\r//g;
    my ($header, $message) = split(/\n\n/, $buf, 2);
    my @header = split(/\n/, $header);
    my $from = '';
    my $date = '';
    my $to = '';
    my $cc = '';
    my $subject = '';
    my $title = '';
    foreach (@header){
      if ($_ =~ /^from:/ig) { $from = $_; }
      elsif ($_ =~ /^date:/ig) { $date = $_; }
      elsif ($_ =~ /^to:/ig) { $to = $_; }
      elsif ($_ =~ /^cc:/ig) { $cc = $_; }
      elsif ($_ =~ /^subject:/ig) { $subject = $_; }
    }
#FIXME: MIME awareness - don't show attachments
    $title = $subject;
    $title =~ s/^subject: //i;
    header($title);
    print "<PRE>";
    print "$date\n" if $date;
    print "$from\n" if $from;
    print "$to\n" if $to;
    print "$cc\n" if $cc;
    print "$subject\n" if $subject;
    print "\n</PRE>";
    print "<PRE>$message</PRE>";
    footer($wfooter);
  }
}

###########################################################################
# Reads a configuration file
# Syntax - do_conf($config_filename);
###########################################################################
sub do_conf{
 # Get the file to read and initialize variables
 my $file = shift;
 my $directive = '';
 my $archive = '';
 my $list_cmd = '';
 my $open_lists = '';

 # Parse the thing
 open CONF, $file;
 while (<CONF>){
  if($_ =~ /^#/){
   # Comments start with a #
  } elsif ($_ =~ /^smtp_server/i){
   ($directive, $main::smtp_server) = split(/=/, $_);
   chomp $main::smtp_server;
  } elsif ($_ =~ /^directory/i){
   ($directive, $main::directory) = split(/=/, $_);
   chomp $main::directory;
  } elsif ($_ =~ /^admin/i){
   ($directive, $main::admin) = split(/=/, $_);
   chomp $main::admin;
  } elsif ($_ =~ /^domain/i){
   ($directive, $main::domain) = split(/=/, $_);
   chomp $main::domain;
  } elsif ($_ =~ /^archive/i){
   ($directive, $main::archive) = split(/=/, $_);
   chomp $main::archive;
  } elsif ($_ =~ /^list_cmd/i){
   ($directive, $main::list_cmd) = split(/=/, $_);
   chomp $main::list_cmd;
  } elsif ($_ =~ /^open_lists/i){
   ($directive, $main::open_lists) = split(/=/, $_);
   chomp $main::open_lists;
  } elsif ($_ =~ /^subject_prefix/i){
   ($directive,$main::subject_pre)=split(/=/, $_);
   chomp $main::subject_pre;
  } elsif ($_ =~ /^url/i){
   ($directive, $main::url) = split(/=/, $_);
   chomp $main::url;
  } elsif ($_ =~ /^bgcolor/i){
   ($directive, $main::bgcolor) = split(/=/, $_);
   chomp $main::bgcolor;
  } elsif ($_ =~ /^text/i){
   ($directive, $main::text) = split(/=/, $_);
   chomp $main::text;
  } elsif ($_ =~ /^link/i){
   ($directive, $main::link) = split(/=/, $_);
   chomp $main::link;
  } elsif ($_ =~ /^vlink/i){
   ($directive, $main::vlink) = split(/=/, $_);
   chomp $main::vlink;
  } elsif ($_ =~ /^alink/i){
   ($directive, $main::alink) = split(/=/, $_);
   chomp $main::alink;
  }

 }
 close CONF;

 # These are space separated
 @main::archive = split(/ /, $main::archive);
 @main::list_cmd = split(/ /, $main::list_cmd);
 @main::open_lists = split(/ /, $main::open_lists);

 # These should be recognized as regular expressions
 $main::subject_pre =~ s/[\r|\n]//g;
 $main::subject_pre =~ s/([\[|\]])/\\$1/g;
}

###########################################################################
# print out the header
# Syntax - header($title);
###########################################################################
sub header {
  my $title = shift;
  print "Content-type: text/html\n\n";
  print qq(
    <HTML><HEAD><TITLE>$title</TITLE>
    <BODY BGCOLOR="$main::bgcolor" TEXT="$main::text" LINK="$main::link"
      ALINK="$main::alink" VLINK="$main::vlink">);
}

###########################################################################
# print the footer
# Syntax - footer($text);
###########################################################################
sub footer {
  my $text = shift;
  print "$text</BODY></HTML>";
}
